// Auto-generated. Do not edit!

// (in-package power_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class BatteryState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.name = null;
      this.charge_level = null;
      this.is_charging = null;
      this.remaining_time = null;
      this.total_capacity = null;
      this.current_capacity = null;
      this.battery_voltage = null;
      this.supply_voltage = null;
      this.charger_voltage = null;
    }
    else {
      if (initObj.hasOwnProperty('name')) {
        this.name = initObj.name
      }
      else {
        this.name = '';
      }
      if (initObj.hasOwnProperty('charge_level')) {
        this.charge_level = initObj.charge_level
      }
      else {
        this.charge_level = 0.0;
      }
      if (initObj.hasOwnProperty('is_charging')) {
        this.is_charging = initObj.is_charging
      }
      else {
        this.is_charging = false;
      }
      if (initObj.hasOwnProperty('remaining_time')) {
        this.remaining_time = initObj.remaining_time
      }
      else {
        this.remaining_time = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('total_capacity')) {
        this.total_capacity = initObj.total_capacity
      }
      else {
        this.total_capacity = 0.0;
      }
      if (initObj.hasOwnProperty('current_capacity')) {
        this.current_capacity = initObj.current_capacity
      }
      else {
        this.current_capacity = 0.0;
      }
      if (initObj.hasOwnProperty('battery_voltage')) {
        this.battery_voltage = initObj.battery_voltage
      }
      else {
        this.battery_voltage = 0.0;
      }
      if (initObj.hasOwnProperty('supply_voltage')) {
        this.supply_voltage = initObj.supply_voltage
      }
      else {
        this.supply_voltage = 0.0;
      }
      if (initObj.hasOwnProperty('charger_voltage')) {
        this.charger_voltage = initObj.charger_voltage
      }
      else {
        this.charger_voltage = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BatteryState
    // Serialize message field [name]
    bufferOffset = _serializer.string(obj.name, buffer, bufferOffset);
    // Serialize message field [charge_level]
    bufferOffset = _serializer.float32(obj.charge_level, buffer, bufferOffset);
    // Serialize message field [is_charging]
    bufferOffset = _serializer.bool(obj.is_charging, buffer, bufferOffset);
    // Serialize message field [remaining_time]
    bufferOffset = _serializer.duration(obj.remaining_time, buffer, bufferOffset);
    // Serialize message field [total_capacity]
    bufferOffset = _serializer.float32(obj.total_capacity, buffer, bufferOffset);
    // Serialize message field [current_capacity]
    bufferOffset = _serializer.float32(obj.current_capacity, buffer, bufferOffset);
    // Serialize message field [battery_voltage]
    bufferOffset = _serializer.float32(obj.battery_voltage, buffer, bufferOffset);
    // Serialize message field [supply_voltage]
    bufferOffset = _serializer.float32(obj.supply_voltage, buffer, bufferOffset);
    // Serialize message field [charger_voltage]
    bufferOffset = _serializer.float32(obj.charger_voltage, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BatteryState
    let len;
    let data = new BatteryState(null);
    // Deserialize message field [name]
    data.name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [charge_level]
    data.charge_level = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [is_charging]
    data.is_charging = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [remaining_time]
    data.remaining_time = _deserializer.duration(buffer, bufferOffset);
    // Deserialize message field [total_capacity]
    data.total_capacity = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [current_capacity]
    data.current_capacity = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [battery_voltage]
    data.battery_voltage = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [supply_voltage]
    data.supply_voltage = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [charger_voltage]
    data.charger_voltage = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.name);
    return length + 37;
  }

  static datatype() {
    // Returns string type for a message object
    return 'power_msgs/BatteryState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ccaf6ecc0ffe8d97f762d3e343f15d67';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Name of the battery
    string name
    
    # Charge level of battery as percentage of maximum charge
    float32 charge_level
    
    # If true, the battery is being charged
    bool is_charging
    
    # When charging, this is the remaining time until fully charged.
    # When discharging, this is the time until battery is empty.
    # Non-zero values are considered valid.
    duration remaining_time
    
    # Total capacity of battery
    float32 total_capacity
    
    # Current capacity of battery
    float32 current_capacity
    
    # Voltage of battery
    float32 battery_voltage
    
    # Voltage of the supply breaker
    float32 supply_voltage
    
    # Voltage of the charger
    float32 charger_voltage
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BatteryState(null);
    if (msg.name !== undefined) {
      resolved.name = msg.name;
    }
    else {
      resolved.name = ''
    }

    if (msg.charge_level !== undefined) {
      resolved.charge_level = msg.charge_level;
    }
    else {
      resolved.charge_level = 0.0
    }

    if (msg.is_charging !== undefined) {
      resolved.is_charging = msg.is_charging;
    }
    else {
      resolved.is_charging = false
    }

    if (msg.remaining_time !== undefined) {
      resolved.remaining_time = msg.remaining_time;
    }
    else {
      resolved.remaining_time = {secs: 0, nsecs: 0}
    }

    if (msg.total_capacity !== undefined) {
      resolved.total_capacity = msg.total_capacity;
    }
    else {
      resolved.total_capacity = 0.0
    }

    if (msg.current_capacity !== undefined) {
      resolved.current_capacity = msg.current_capacity;
    }
    else {
      resolved.current_capacity = 0.0
    }

    if (msg.battery_voltage !== undefined) {
      resolved.battery_voltage = msg.battery_voltage;
    }
    else {
      resolved.battery_voltage = 0.0
    }

    if (msg.supply_voltage !== undefined) {
      resolved.supply_voltage = msg.supply_voltage;
    }
    else {
      resolved.supply_voltage = 0.0
    }

    if (msg.charger_voltage !== undefined) {
      resolved.charger_voltage = msg.charger_voltage;
    }
    else {
      resolved.charger_voltage = 0.0
    }

    return resolved;
    }
};

module.exports = BatteryState;
